## 2.十分钟快速部署

在本篇文档中，将会介绍为已有的keil工程部署PikaScript的方法。

PikaScript几乎没有全局变量和宏，仅依赖标准库，因此为已有的工程部署PikaScript是非常容易的。

下面是部署PikaScript的具体步骤。

### (1)下载PikaScript源码

进入PikaScript主仓库

https://github.com/mimilib/pikascript

打开发布页面

![image](https://user-images.githubusercontent.com/88232613/130962133-d7984e05-da83-4ac6-bec6-ff603ce058f1.png)

下载最新发布的PikaScript软件包

![image](https://user-images.githubusercontent.com/88232613/130962168-91045ccc-3c6d-434c-b147-30b298025822.png)

解压后得到一个pikascript文件夹，直接将这个文件夹复制到keil工程里面

![image](https://user-images.githubusercontent.com/88232613/130965530-d2f0fe25-2a4b-4286-b3ed-c534ac182e35.png)

例如可以复制到keil工程的根目录

![image](https://user-images.githubusercontent.com/88232613/130965822-754a5495-00c8-4f1f-b7bb-d1755d56c6fe.png)

### (2)调整堆栈

打开工程的启动文件

![image](https://user-images.githubusercontent.com/88232613/130966276-24014a0a-90a6-4bd7-96b7-fde54806b8c3.png)

建议分配4K的栈空间和16K的堆空间，最少也需要分配2K的栈空间和8K的堆空间

4K栈空间对应0x1000, 16K堆空间对应0x4000，如下图所示

![image](https://user-images.githubusercontent.com/88232613/130967178-a985a4f5-730c-47fd-9317-68f33bc00066.png)

### (3)添加源码

在Project中新建三个group，建议命名为pikascript-core,pikascript-api和pikascript-lib

![image](https://user-images.githubusercontent.com/88232613/130967351-597b8f6b-cc4e-4bc3-9cb6-2f335e5dccea.png)

然后将pikascript文件夹内的三个子文件夹下的.c文件全部添加到keil工程里

![image](https://user-images.githubusercontent.com/88232613/130971776-41d8c940-42d0-407d-872e-53525ce299a6.png)

再然后为pikascript-core和pikascript-api文件夹添加include路径

![image](https://user-images.githubusercontent.com/88232613/130967813-94016b8a-e408-4b49-b1e1-76a5df5fe984.png)

![image](https://user-images.githubusercontent.com/88232613/130967949-8399c65b-5584-4674-a947-e40103d953ea.png)

### (4)初始化PikaScript

在初始化代码中添加PikaScript，通常是在main.c中

1) 添加 #include "pikascript.h"

![image](https://user-images.githubusercontent.com/88232613/130969048-4def9902-5f36-4798-9eac-ebbb1441087f.png)

2) 初始化pikaScript并得到pikascript主对象的指针pikaMain

![image](https://user-images.githubusercontent.com/88232613/130969274-ff2fdf6f-2389-466b-b51e-e7bc33472558.png)


### (5)编译源码

编译源码时需要勾选C99标准

![image](https://user-images.githubusercontent.com/88232613/130968626-7d8d4f46-eb0c-4ccd-9c34-eab160b290f5.png)

pikascript需要printf库函数，因此需要勾选Use MiroLIB使得工程支持printf。

![image](https://user-images.githubusercontent.com/88232613/130969859-848b7149-93c6-4ea3-a955-2388b6d9392c.png)

然后直接编译即可，一般来说是可以直接通过的，使用compiler version 5 或者 compiler version 6均可。

### 结语

部署文档到此就结束了。继续学习PikaScript的标准开发流程请看

[3. PikaScipt标准开发流程](./3.PikaScript标准开发流程.md)
